Index: trunk/source/processes/electromagnetic/standard/src/G4PAIPhotonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PAIPhotonModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4PAIPhotonModel.cc	(revision 1055)
@@ -24,4 +24,10 @@
 // ********************************************************************
 //
+// $Id: G4PAIPhotonModel.cc,v 1.22 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class 
 // File name:     G4PAIPhotonModel.cc
 //
@@ -160,8 +166,5 @@
   if(!fParticle) SetParticle(p);
 
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForLoss*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForLoss();
+  fParticleChange = GetParticleChangeForLoss();
 
   const G4ProductionCutsTable* theCoupleTable =
@@ -214,4 +217,9 @@
   }
 }
+
+//////////////////////////////////////////////////////////////////
+
+void G4PAIPhotonModel::InitialiseMe(const G4ParticleDefinition*)
+{}
 
 //////////////////////////////////////////////////////////////////
@@ -487,5 +495,6 @@
   {
     //  if ( x1 == x2  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
-    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    //    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*0.5 ;
     else             dNdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
@@ -530,5 +539,6 @@
   {
     //  if ( x1 == x2  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
-    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    //    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*0.5 ;
     else             dNdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
@@ -574,5 +584,6 @@
   {
     //  if ( x1 == x2  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
-    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    //    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*0.5 ;
     else             dNdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
@@ -617,5 +628,6 @@
   {
     //  if ( x1 == x2  ) dEdxCut = y1 + (y2 - y1)*G4UniformRand() ;
-    if ( std::abs(x1-x2) <= eV  ) dEdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    //    if ( std::abs(x1-x2) <= eV  ) dEdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    if ( std::abs(x1-x2) <= eV  ) dEdxCut = y1 + (y2 - y1)*0.5 ;
     else             dEdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
@@ -626,11 +638,15 @@
 //////////////////////////////////////////////////////////////////////////////
 
-G4double G4PAIPhotonModel::ComputeDEDX(const G4MaterialCutsCouple* matCC,
-                                 const G4ParticleDefinition* p,
-                                       G4double kineticEnergy,
-                                       G4double cutEnergy)
+G4double G4PAIPhotonModel::ComputeDEDXPerVolume(const G4Material*,
+						const G4ParticleDefinition* p,
+						G4double kineticEnergy,
+						G4double cutEnergy)
 {
   G4int iTkin,iPlace;
   size_t jMat;
+
+  //G4double cut = std::min(MaxSecondaryEnergy(p, kineticEnergy), cutEnergy);
+  G4double cut = cutEnergy;
+
   G4double particleMass = p->GetPDGMass();
   G4double scaledTkin   = kineticEnergy*proton_mass_c2/particleMass;
@@ -638,4 +654,5 @@
   G4double charge2      = charge*charge;
   G4double dEdx         = 0.;
+  const G4MaterialCutsCouple* matCC = CurrentCouple();
 
   for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
@@ -653,5 +670,5 @@
   iPlace = iTkin - 1;
   if(iPlace < 0) iPlace = 0;
-  dEdx = charge2*( (*fdEdxVector)(iPlace) - GetdEdxCut(iPlace,cutEnergy) ) ;  
+  dEdx = charge2*( (*fdEdxVector)(iPlace) - GetdEdxCut(iPlace,cut) ) ;  
 
   if( dEdx < 0.) dEdx = 0.;
@@ -661,13 +678,14 @@
 /////////////////////////////////////////////////////////////////////////
 
-G4double G4PAIPhotonModel::CrossSection( const G4MaterialCutsCouple* matCC,
-                                   const G4ParticleDefinition* p,
-                                         G4double kineticEnergy,
-                                         G4double cutEnergy,
-                                         G4double maxEnergy  ) 
+G4double G4PAIPhotonModel::CrossSectionPerVolume( const G4Material*,
+						  const G4ParticleDefinition* p,
+						  G4double kineticEnergy,
+						  G4double cutEnergy,
+						  G4double maxEnergy  ) 
 {
   G4int iTkin,iPlace;
   size_t jMat, jMatCC;
-  G4double tmax = min(MaxSecondaryEnergy(p, kineticEnergy), maxEnergy);
+  G4double tmax = std::min(MaxSecondaryEnergy(p, kineticEnergy), maxEnergy);
+  if(cutEnergy >= tmax) return 0.0;
   G4double particleMass = p->GetPDGMass();
   G4double scaledTkin   = kineticEnergy*proton_mass_c2/particleMass;
@@ -675,4 +693,6 @@
   G4double charge2      = charge*charge, cross, cross1, cross2;
   G4double photon1, photon2, plasmon1, plasmon2;
+
+  const G4MaterialCutsCouple* matCC = CurrentCouple();
 
   const G4ProductionCutsTable* theCoupleTable=
@@ -1225,4 +1245,28 @@
 }
 
+/////////////////////////////////////////////////////////////////////
+
+G4double G4PAIPhotonModel::MaxSecondaryEnergy( const G4ParticleDefinition* p,
+                                                      G4double kinEnergy) 
+{
+  G4double tmax = kinEnergy;
+  if(p == fElectron) tmax *= 0.5;
+  else if(p != fPositron) { 
+    G4double mass = p->GetPDGMass();
+    G4double ratio= electron_mass_c2/mass;
+    G4double gamma= kinEnergy/mass + 1.0;
+    tmax = 2.0*electron_mass_c2*(gamma*gamma - 1.) /
+                  (1. + 2.0*gamma*ratio + ratio*ratio);
+  }
+  return tmax;
+}
+
+///////////////////////////////////////////////////////////////
+
+void G4PAIPhotonModel::DefineForRegion(const G4Region* r) 
+{
+  fPAIRegionVector.push_back(r);
+}
+
 
 //
Index: trunk/source/processes/electromagnetic/standard/src/G4PEEffectModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PEEffectModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4PEEffectModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PEEffectModel.cc,v 1.6 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PEEffectModel.cc,v 1.8 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -41,4 +41,6 @@
 //
 // 04.12.05 : SetProposedKineticEnergy(0.) for the killed photon (mma)
+// 20.02.09 : Added initialisation of deexcitation flag and method
+//            CrossSectionPerVolume instead of mfp (V.Ivanchenko)
 //
 // Class Description:
@@ -66,4 +68,5 @@
   theGamma    = G4Gamma::Gamma();
   theElectron = G4Electron::Electron();
+  fminimalEnergy = 1.0*eV;
 }
 
@@ -71,6 +74,5 @@
 
 G4PEEffectModel::~G4PEEffectModel()
-{
-}
+{}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -79,12 +81,45 @@
 				 const G4DataVector&)
 {
- if (isInitialized) return;
- if (pParticleChange)
-   fParticleChange =
-                  reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-   fParticleChange = new G4ParticleChangeForGamma();
-
- fminimalEnergy = 1.0*eV;
+  // always false before the run
+  SetDeexcitationFlag(false);
+
+  if (isInitialized) return;
+  fParticleChange = GetParticleChangeForGamma();
+  isInitialized = true;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo.....
+
+G4double G4PEEffectModel::ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
+						     G4double energy,
+						     G4double Z, G4double,
+						     G4double, G4double)
+{
+  G4double* SandiaCof = G4SandiaTable::GetSandiaCofPerAtom((G4int)Z, energy);
+
+  G4double energy2 = energy*energy;
+  G4double energy3 = energy*energy2;
+  G4double energy4 = energy2*energy2;
+
+  return SandiaCof[0]/energy  + SandiaCof[1]/energy2 +
+    SandiaCof[2]/energy3 + SandiaCof[3]/energy4;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+G4double G4PEEffectModel::CrossSectionPerVolume(const G4Material* material,
+						const G4ParticleDefinition*,
+						G4double energy,
+						G4double, G4double)
+{
+  G4double* SandiaCof = 
+    material->GetSandiaTable()->GetSandiaCofForMaterial(energy);
+				
+  G4double energy2 = energy*energy;
+  G4double energy3 = energy*energy2;
+  G4double energy4 = energy2*energy2;
+	  
+  return SandiaCof[0]/energy  + SandiaCof[1]/energy2 +
+    SandiaCof[2]/energy3 + SandiaCof[3]/energy4; 
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4PhotoElectricEffect.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PhotoElectricEffect.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4PhotoElectricEffect.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PhotoElectricEffect.cc,v 1.41 2008/10/16 14:12:32 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PhotoElectricEffect.cc,v 1.42 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -89,4 +89,11 @@
 {}
 
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+G4bool G4PhotoElectricEffect::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (&p == G4Gamma::Gamma());
+}
+
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
Index: trunk/source/processes/electromagnetic/standard/src/G4UniversalFluctuation.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4UniversalFluctuation.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4UniversalFluctuation.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4UniversalFluctuation.cc,v 1.16 2008/10/22 16:04:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4UniversalFluctuation.cc,v 1.22 2009/03/20 18:11:23 urban Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -57,5 +57,7 @@
 // 03-04-07 correction to get better width of eloss distr.(L.Urban)
 // 13-07-07 add protection for very small step or low-density material (VI)
-//          
+// 19-03-09 new width correction (does not depend on previous steps) (L.Urban)         
+// 20-03-09 modification in the width correction (L.Urban)
+//
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -84,7 +86,4 @@
 {
   lastMaterial = 0;
-  facwidth     = 1.000/keV;
-  oldloss = 0.;
-  samestep = 0.;
 }
 
@@ -120,8 +119,5 @@
   //
   if (meanLoss < minLoss)
-  { 
-    oldloss = meanLoss;
     return meanLoss;
-  }
 
   if(!particle) InitialiseMe(dp->GetDefinition());
@@ -179,4 +175,15 @@
     e0 = material->GetIonisation()->GetEnergy0fluct();
     lastMaterial = material;
+  
+    // modification of some model parameters
+    // (this part should go to materials later)
+    G4double p = 1.40;
+    f2Fluct *= p;
+    f1Fluct = 1.-f2Fluct;
+    G4double q = 1.00;
+    e2Fluct *= q;
+    e2LogFluct = log(e2Fluct);
+    e1LogFluct = (ipotLogFluct-f2Fluct*e2LogFluct)/f1Fluct;
+    e1Fluct = exp(e1LogFluct);
   }
 
@@ -185,15 +192,4 @@
 
   G4double a1 = 0. , a2 = 0., a3 = 0. ;
-
-  // correction to get better width even using stepmax
-  if(abs(meanLoss- oldloss) < 1.*eV)
-    samestep += 1;
-  else
-    samestep = 1.;
-  oldloss = meanLoss;
-  G4double width = 1.+samestep*facwidth*meanLoss;
-  if(width > 4.50) width = 4.50;
-  e1 = width*e1Fluct;
-  e2 = width*e2Fluct;
 
   // cut and material dependent rate 
@@ -206,6 +202,18 @@
       rate = 0.03+0.23*log(log(tmax/ipotFluct));
       G4double C = meanLoss*(1.-rate)/(w2-ipotLogFluct);
-      a1 = C*f1Fluct*(w2-e1LogFluct)/e1;
-      a2 = C*f2Fluct*(w2-e2LogFluct)/e2;
+      a1 = C*f1Fluct*(w2-e1LogFluct)/e1Fluct;
+      a2 = C*f2Fluct*(w2-e2LogFluct)/e2Fluct;
+      // correction in order to get better FWHM values
+      // ( scale parameters a1 and e1)
+      G4double width = 1.;
+      if(meanLoss > 10.*e1Fluct)
+      {
+        width = 3.1623/sqrt(meanLoss/e1Fluct);
+        if(width < a2/a1)
+        width = a2/a1;
+      } 
+      a1 *= width;
+      e1 = e1Fluct/width;
+      e2 = e2Fluct;
     }
   }
@@ -305,3 +313,16 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+void 
+G4UniversalFluctuation::SetParticleAndCharge(const G4ParticleDefinition* part,
+					     G4double q2)
+{
+  if(part != particle) {
+    particle       = part;
+    particleMass   = part->GetPDGMass();
+  }
+  chargeSquare = q2;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
